/// <reference types="node" />
import { WsOPCUAServer } from "./ws/ws-opcua-server";
import { EventEmitter } from "events";
/**
 * emits following events:
 * 'test-server-started' : WsOPCUAServer
 * 'test-server-stopped': WsOPCUAServer
 */
export declare class Controller extends EventEmitter {
    private controlServer;
    private namespace;
    private testServer?;
    nodesetMap: Map<string, string>;
    constructor(controlServer: WsOPCUAServer, namespace: number);
    protected init(): void;
    startTestServer(namespaces: string[]): Promise<void>;
    stopTestServer(): Promise<void>;
    reloadNamespace(namespaceUri: string): void;
    /**
     *
     * @param namespaceUri
     * @returns the namespace index of the deleted namespace (-1 if not found)
     */
    private deleteNamespace;
    loadNamespace(namespaceUri: string, index: number): void;
}
