/// <reference types="node" />
import { IncomingMessage } from "http";
import { EndpointDescriptionParams, MessageSecurityMode, OPCUAServerEndPoint, OPCUAServerEndpointOptions, SecurityPolicy, ServerSecureChannelLayer } from "node-opcua";
import * as ws from "ws";
export declare enum TransportType {
    TCP = 0,
    WEBSOCKET = 1,
    WEBSOCKET_SECURE = 2
}
export interface OPCUAWsServerEndpointOptions extends OPCUAServerEndpointOptions {
    transportType: TransportType;
}
export declare class OPCUAWsServerEndPoint extends OPCUAServerEndPoint {
    protected _server?: ws.Server;
    protected _started: boolean;
    protected _channels: {
        [key: string]: ServerSecureChannelLayer;
    };
    private _setup_server;
    private _dump_statistics;
    protocolName(): string;
    listen(callback: (err?: Error | undefined) => void): void;
    protected createWSServer(): ws.Server;
    protected _verifyClient(info: {
        origin: string;
        secure: boolean;
        req: IncomingMessage;
    }): boolean;
    addEndpointDescription(securityMode: MessageSecurityMode, securityPolicy: SecurityPolicy, options?: EndpointDescriptionParams): void;
}
export declare class OPCUAWsSecureServerEndPoint extends OPCUAWsServerEndPoint {
    protected createWSServer(): ws.Server;
    protocolName(): string;
}
