"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebSocketSocketWrapper = void 0;
class WebSocketSocketWrapper {
    constructor(websocket) {
        this.webSocket = websocket;
    }
    write(str, encoding, cb) {
        this.webSocket.send(str);
        return false;
    }
    connect(port, host, connectionListener) {
        throw new Error('Method not implemented.');
        return this;
    }
    setEncoding(encoding) {
        throw new Error('Method not implemented.');
    }
    pause() {
        //       this.webSocket._socket.pause();
        return this;
    }
    resume() {
        //       this.webSocket._socket.resume();
        return this;
    }
    setTimeout(timeout, callback) {
        // TODO: check if we should set this
        //       this.webSocket._socket.setTimeout(timeout,callback);
        return this;
    }
    setNoDelay(noDelay) {
        // TODO: check if we should set this
        //       this.webSocket._socket.setNoDelay(noDelay);
        return this;
    }
    setKeepAlive(enable, initialDelay) {
        throw new Error('Method not implemented.');
    }
    address() {
        return this.webSocket._socket.address();
    }
    unref() {
        throw new Error('Method not implemented.');
    }
    ref() {
        throw new Error('Method not implemented.');
    }
    get bufferSize() {
        return this.webSocket.bufferedAmount;
    }
    get bytesWritten() {
        return this.webSocket._socket.bytesWritten;
    }
    get connecting() {
        return this.webSocket._socket.connecting;
    }
    get destroyed() {
        return this.webSocket._socket.destroyed;
    }
    get localAddress() {
        return this.webSocket._socket.localAddress;
    }
    get localPort() {
        return this.webSocket._socket.localPort;
    }
    get remoteAddress() {
        return this.webSocket._socket.remoteAddress;
    }
    get remoteFamily() {
        return this.webSocket._socket.remoteFamily;
    }
    get remotePort() {
        return this.webSocket._socket.remotePort;
    }
    end(str, encoding, cb) {
        this.webSocket.close();
    }
    addListener(event, listener) {
        switch (event) {
            case 'data':
                this.webSocket.addEventListener('message', (evt) => {
                    listener(evt.data);
                });
                break;
            case 'close':
                //TODO: removeEventListener fails for this
                this.webSocket.addEventListener('close', (evt) => {
                    listener(!evt.wasClean);
                });
                break;
            case 'error':
                //TODO: removeEventListener fails for this
                this.webSocket.addEventListener('error', (evt) => {
                    listener(evt.error);
                });
                break;
            case 'connect':
                this.webSocket.addEventListener('open', listener);
                break;
            case 'end':
                this.webSocket._socket.addListener('end', listener);
                break;
            default:
                this.webSocket.addListener(event, listener);
                break;
        }
        return this;
    }
    emit(event, ...args) {
        return this.webSocket.emit(event, ...args);
    }
    on(event, listener) {
        return this.addListener(event, listener);
    }
    once(event, listener) {
        throw new Error('Method not implemented.');
        return this;
    }
    prependListener(event, listener) {
        throw new Error('Method not implemented.');
        return this;
    }
    prependOnceListener(event, listener) {
        throw new Error('Method not implemented.');
        return this;
    }
    get writable() {
        return this.webSocket._socket.writable;
    }
    get writableEnded() {
        return this.webSocket._socket.writableEnded;
    }
    get writableFinished() {
        return this.webSocket._socket.writableFinished;
    }
    get writableHighWaterMark() {
        return this.webSocket._socket.writableHighWaterMark;
    }
    get writableLength() {
        return this.webSocket._socket.writableLength;
    }
    get writableObjectMode() {
        return this.webSocket._socket.writableObjectMode;
    }
    get readable() {
        return this.webSocket._socket.readable;
    }
    ;
    get readableEncoding() {
        return this.webSocket._socket.readableEncoding;
    }
    get readableEnded() {
        return this.webSocket._socket.readableEnded;
    }
    get readableFlowing() {
        return this.webSocket._socket.readableFlowing;
    }
    get readableHighWaterMark() {
        return this.webSocket._socket.readableHighWaterMark;
    }
    get readableLength() {
        return this.webSocket._socket.readableLength;
    }
    get readableObjectMode() {
        return this.webSocket._socket.readableObjectMode;
    }
    get bytesRead() {
        return this.webSocket._socket.bytesRead;
    }
    _write(chunk, encoding, callback) {
        throw new Error('Method not implemented.');
    }
    _destroy(error, callback) {
        throw new Error('Method not implemented.');
    }
    _final(callback) {
        throw new Error('Method not implemented.');
    }
    setDefaultEncoding(encoding) {
        throw new Error('Method not implemented.');
    }
    cork() {
        throw new Error('Method not implemented.');
    }
    uncork() {
        throw new Error('Method not implemented.');
    }
    _read(size) {
        throw new Error('Method not implemented.');
    }
    read(size) {
        throw new Error('Method not implemented.');
    }
    isPaused() {
        return this.webSocket._socket.isPaused();
    }
    unpipe(destination) {
        throw new Error('Method not implemented.');
    }
    unshift(chunk, encoding) {
        throw new Error('Method not implemented.');
    }
    wrap(oldStream) {
        throw new Error('Method not implemented.');
    }
    push(chunk, encoding) {
        throw new Error('Method not implemented.');
    }
    destroy(error) {
        // TODO: check if we should use net.socket.destroy instead
        this.webSocket.close();
    }
    removeListener(event, listener) {
        // TODO: implement it symmetrically to the the addListener !!!
        this.webSocket.removeListener(event, listener);
        return this;
    }
    [Symbol.asyncIterator]() {
        throw new Error('Method not implemented.');
    }
    pipe(destination, options) {
        throw new Error('Method not implemented.');
    }
    off(event, listener) {
        this.removeListener(event, listener);
        return this;
    }
    removeAllListeners(event) {
        this.webSocket.removeAllListeners(event);
        return this;
    }
    setMaxListeners(n) {
        throw new Error('Method not implemented.');
    }
    getMaxListeners() {
        return this.webSocket._socket.getMaxListeners();
    }
    listeners(event) {
        throw new Error('Method not implemented.');
    }
    rawListeners(event) {
        throw new Error('Method not implemented.');
    }
    eventNames() {
        throw new Error('Method not implemented.');
    }
    listenerCount(type) {
        throw new Error('Method not implemented.');
    }
}
exports.WebSocketSocketWrapper = WebSocketSocketWrapper;
//# sourceMappingURL=websocket-socket-wrapper.js.map